/**********************************************************
Rechenprogramm fr arithmetische Ausdrcke
Kann Grundrechenarten mit Punkt-Vor-Strich und Klammern
Kann KEINE Vorzeichen!!!!!
**********************************************************/
#include <stdio.h>
#include "automaten_mathe_scanner.c"

#define STACK_HEIGHT 10

int kellerautomat(char *, double *);
int keller_r(double, double, int, double *);

int kellerautomat(char *input, double *z) {
    double zk[STACK_HEIGHT];         // Zahlenkeller
    int ok[STACK_HEIGHT];            // Operandenkeller
    int oh = -1, zh = -1;   // Operandenhhe, Zahlenhhe
    double z1, z2, z3;
    int token, error = 0;
    char aktion, ptable[6][7]={
/*              END  +   -   *   /   (   )   */
/* END     */  {'X','K','K','K','K','K','F'},
/* +       */  {'D','G','G','K','K','K','D'},
/* -       */  {'D','G','G','K','K','K','D'},
/* *       */  {'D','D','D','G','G','K','D'},
/* /       */  {'D','D','D','G','G','K','D'},
/* (       */  {'F','K','K','K','K','K','L'}};

    mathescanner(input, NULL); // Scanner-Reset
    ok[++oh] = END;
    do {
        token = mathescanner(input, &z1);
        if (token == ZAHL) // Zahl abkellern
            zk[++zh] = z1;
        else if (token == FEHLER)
            error = 3;
        else // Operand
            do {
                aktion = ptable[ok[oh]][token];
                switch (aktion) {
                case 'K':   // Operator kellern
                    ok[++oh] = token;
                    break;
                case 'G':   // Gleichrangige Operation
                    z2 = zk[zh--];
                    z1 = zk[zh--];
                    error = keller_r(z1, z2, ok[oh--], &z3);
                    if (!error) {
                        zk[++zh] = z3;    // Ergebnis auf Stack
                        ok[++oh] = token; // Neuer Operand
                    }
                    break;
                case 'D':   // Keller abarbeiten
                    z2 = zk[zh--];
                    z1 = zk[zh--];
                    error = keller_r(z1, z2, ok[oh--], &z3);
                    if (!error)
                        zk[++zh] = z3;    // Ergebnis auf Stack
                    break;
                case 'L':   // Gekellerte Klammer lschen
                    oh--;
                    break;
                case 'F':   // Gekellerte Klammer lschen
                    error = 1;
                    break;
                }
            } while (!error && aktion == 'D');
    } while (!error && token != END);
    if (zh != 0)
        error = 2;
    if (!error)
        *z = zk[0];
    return error;
}

int keller_r(double z1, double z2, int operator, double *z3) {
    switch (operator) {
    case PLUS:  *z3 = z1 + z2; return 0;
    case MINUS: *z3 = z1 - z2; return 0;
    case MAL:   *z3 = z1 * z2; return 0;
    case DIV:   if (z2 == 0)   return 1;
                *z3 = z1 / z2; return 0;
    }
}

int main() {
    char t[256];
    int retcode;
    double z;
    while (printf("Rechnung: "),fgets(t, 255, stdin) != NULL)
        if ((retcode = kellerautomat(t, &z)) == 0)
            printf("Ergebnis: %lf\n\n", z);
        else
            printf("Fehler %d\n\n", retcode);
    printf("\n");
    return 0;
}
