/**********************************************************
BCD-Erkenner via Automat
**********************************************************/
#include <stdio.h>

int bcd_scanner(char *, int);
int bcd_parser(char *);

int main() {
    char input[255];

    while(printf("BCD-Input: "),fgets(input, 255, stdin)!= NULL)
        printf("%sOK!\n", (bcd_parser(input))?"Nicht ":"");

    printf("\n");
    return 0;
}

int bcd_parser(char *in) {
    int zustand = 0;
    static int ptable[7][4] = { /*0*/ {7,1,4,8},
                                /*1*/ {8,2,2,8},
                                /*2*/ {8,3,3,8},
                                /*3*/ {8,0,0,8},
                                /*4*/ {8,5,8,8},
                                /*5*/ {8,6,8,8},
                                /*6*/ {8,0,0,8}};
    bcd_scanner(in,1); // Scanner-Reset
    while (zustand < 7)
        zustand = ptable[zustand][bcd_scanner(in, 0)];
    return zustand == 8;
}


int bcd_scanner(char *in, int reset) {
    static char *p;
    enum {token_end, token_0, token_1, token_fehler};
    if (reset) {
        p = in;
        return 0;
    }
    switch (*p++) {
    case '0':   return token_0;
    case '1':   return token_1;
    case '\0':
    case '\n':  return token_end;
    default:    return token_fehler;
    }
}