/**********************************************************
Rechner fr arithmetische Ausdrcke
OHNE Punkt-vor-Strich und OHNE Klammern
**********************************************************/
#include <stdio.h>
#include "automaten_mathe_scanner.c"

int mathe_parser(char *in, double *z) {
	int zustand = 0, op = PLUS, vz = PLUS, token;
	double zahl;
	int parsetable[3][9]={/*|E|+|-|*|/|(|)|Z|F*/
	                  /*0*/ {4,2,2,4,4,4,4,1,4},
					  /*1*/ {3,0,0,0,0,4,4,4,4},
                      /*2*/ {4,4,4,4,4,4,4,1,4}};
		
    mathescanner(in, NULL);
    *z = 0;
		
    while (zustand < 3) {
        token = mathescanner(in, &zahl);
//      printf("%d %d", zustand, token);
		zustand = parsetable[zustand][token];
//      printf(" -> %d\n", zustand);
		switch (zustand) {
		case 0: // Operator merken
		        op = token;
		        break;
		case 1: // Rechnen
		        if (vz == MINUS)
		            zahl = -zahl;
		        switch (op) {
		        case PLUS:  *z += zahl;
		                    break;
		        case MINUS: *z -= zahl;
		                    break;
		        case MAL:   *z *= zahl;
		                    break;
		        case DIV:   if (zahl != 0)
    		                    *z /= zahl;
    		                else
    		                    zustand = 4;
		                    break;
		        }
		        vz = PLUS;
		        break;
		case 2: // Vorzeichen merken
		        vz = token;
		        break;
		default:
		}
	}
    return zustand != 3;
}

int main() {
	char in[255];
	double x;
	while (printf("Brauche Input: "),fgets(in,255,stdin)!=NULL)
	    if (!mathe_parser(in, &x))
    		printf("Ergebnis: %lf\n",x);
        else
    		printf("Eingabe nicht OK!\n");
	
	printf("\n");
}
