/******************************************************************************
Lexikalische Analyse fr mathematische Ausdrcke die aus Zahlen und den
Grundrechenarten bestehen.
******************************************************************************/

#define END		0
#define PLUS	1
#define MINUS	2
#define MAL		3
#define DIV		4
#define KLA_AUF	5
#define KLA_ZU	6
#define ZAHL	7
#define FEHLER	8

int lex_mathe(char *input,double *wert) {
	static int pos;
	static unsigned char myinput[255] = "";
	static int table[5][4] = {	/*0*/ {6,1,3,2},
								/*1*/ {5,5,5,5},
								/*2*/ {5,5,3,2},
								/*3*/ {6,6,6,4},
								/*4*/ {5,5,5,6}};
	static int klassentab[256],firsttime;
	unsigned char zeichen, wort[25], zustand = 0, klasse, lang=0;
								
	if (!firsttime) { // klassentab beim ersten Aufruf initialisieren
		int i;
		firsttime=1;
		for (i=0; i<256; i++)
			klassentab[i]=0; // Fehler
		for (i='0'; i<='9'; i++)
			klassentab[i] = 3; // Ziffer
		klassentab['+'] = 1;
		klassentab['-'] = 1;
		klassentab['*'] = 1;
		klassentab['/'] = 1;
		klassentab['('] = 1;
		klassentab[')'] = 1;
		klassentab['.'] = 2;
	}

	if (strcmp(input, myinput)) { // Aufruf mit neuem String
		strcpy(myinput, input);
		pos=0;
	}
	
	*wert = 0;
	while (myinput[pos] == ' ')
		pos++;
	if (myinput[pos] == 0)
		return END;
	do {
		zeichen = myinput[pos++];
		wort[lang++]=zeichen;
		zustand = table[zustand][klassentab[zeichen]];
	} while (zustand < 5);
	wort[lang]=0;
	if (zustand == 6)
		return FEHLER;
	
	pos--;				// Lookahead rckgngig machen
	wort[lang-1]=0;

	switch (wort[0]) {
		case '+':	return PLUS;
		case '-':	return MINUS;
		case '*':	return MAL;
		case '/':	return DIV;
		case '(':	return KLA_AUF;
		case ')':	return KLA_ZU;
		default:	*wert = atof(wort);
					return ZAHL;
	}
}
