/*****************************************************************************
Rechner fr mathematische Grundrechenarten mit Punkt-vor-Strich
Gelst ber Kellerautomat mit zwei Kellern fr Zahlen und Operatoren
Winfried Bantel / BA Stuttgart
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "mathe_scanner.c"

double rechner (char *input) {
	int token, zustand,operator,vorzeichen,zahlenzeiger,operatorzeiger,operatorkeller[256];
	double wert,zahl, zahl_1, zahl_2, zahlenkeller[256];
	int parsetable[3][7]={	{4,2,2,4,4,1,4},
							{0,0,0,0,0,4,4},
							{4,4,4,4,4,1,4}};
	int prioritaet[256];
	
	prioritaet[PLUS] = 1;
	prioritaet[MINUS] = 1;
	prioritaet[MAL] = 2;
	prioritaet[DIV] = 2;
	prioritaet[END] = 0;
	zustand = 0;
	wert=0;
	vorzeichen = PLUS;
	operator=PLUS;
	zahlenzeiger = -1;
	operatorzeiger = 0;
	operatorkeller[0] = 255;
	do {
		token = lex_mathe(input, &zahl);
//		printf("Zustand %d Token %d gehe zu %d\n",zustand,token,parsetable[zustand][token]);
		zustand = parsetable[zustand][token];
		switch (zustand) { // Jetzt Programmcode der ausprogrammiert werden muss
		case 0: // Operator merken
			if (operatorkeller[operatorzeiger] == 255) {
				operatorkeller[++operatorzeiger] = token; // erster Operator
//				printf("Keller 1. Operator: %d\n", token);
			}
			else if (prioritaet[token] > prioritaet[operatorkeller[operatorzeiger]]) {
				operatorkeller[++operatorzeiger] = token; // erster Operator
//				printf("Keller Folgeoperator: %d\n", token);
			}
			else {
				while (operatorzeiger && prioritaet[token] <= prioritaet[operatorkeller[operatorzeiger]]) {
					zahl_1 = zahlenkeller[zahlenzeiger--];
					zahl_2 = zahlenkeller[zahlenzeiger--];
					operator = operatorkeller[operatorzeiger--];
					switch (operator) {
					case PLUS:	wert = zahl_2 + zahl_1;
//								printf("OP: %lf + %lf\n",zahl_2, zahl_1);
								break;
					case MINUS: wert = zahl_2 - zahl_1;
//								printf("OP: %lf - %lf\n",zahl_2, zahl_1);
								break;
					case MAL:	wert = zahl_2 * zahl_1;
//								printf("OP: %lf * %lf\n",zahl_2, zahl_1);
								break;
					case DIV:	wert = zahl_2 / zahl_1;
//								printf("OP: %lf / %lf\n",zahl_2, zahl_1);
								break;
					default:	printf("Fehler im Operator!\n");
					}
					zahlenkeller[++zahlenzeiger] = wert;
//					printf("Kellere Zahl %lf\n",wert);
				}
				if (token) {
					operatorkeller[++operatorzeiger] = token;
//					printf("Keller Operator: %d\n", token);
				}
			}					
			break;
		case 1: // Zahl gefunden
			zahl = (vorzeichen == PLUS) ? zahl : -zahl;
			zahlenkeller[++zahlenzeiger] = zahl;
			vorzeichen=PLUS; // Default-Vorzeichen fr nchste Zahl
//			printf("Kellere Zahl %lf\n",zahl);
				break;
			case 2: // Vorzeichen merken
				vorzeichen = token;
				break;
			default:
		}
	} while (token);
		
	if (zustand != 4)
		return zahlenkeller[0];
	printf("Eingabe war nicht OK!\n");
}


int main() {
	char input[255];
	
	while (1) {
		printf("Brauche Input: ");
		fgets(input,255,stdin);
		input[strlen(input)-1] = 0;
		if (!*input)
			break;
		printf("Ergebnis: %lf\n",rechner(input));
	}
}
