/*****************************************************************************
Rechner fr mathematische Grundrechenarten mit Punkt-vor-Strich und Klammern
Gelst ber Kellerautomat mit zwei Kellern fr Zahlen und Operatoren
Klammern ber rekursiven Abstieg  ohne nderung der Automaten
Winfried Bantel / BA Stuttgart 2000
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mathe_scanner.c"

double rechner (char *input) {
	int token, zustand,op,vorzeichen,zahlenzeiger;
	int opzeiger,opkeller[256];
	double wert,zahl, zahl_1, zahl_2, zahlenkeller[256];
	int parsetable[3][7]={	{4,2,2,4,4,1,4},
							{0,0,0,0,0,4,4},
							{4,4,4,4,4,1,4}};
	int p[256]; // Prioritt der Operatoren
	char *pos_1, *pos_2;
/*********************************************************
Hier die eigentliche nderung, die Suche nach Klammern und
der rekursive Abstieg.
*********************************************************/	
	pos_1 = strchr(input,'('); // Pointer auf erste '('
	pos_2 = strrchr(input,')');// Pointer auf letzte ')'
	if (pos_1 && pos_2 && pos_2 > pos_1) { // Klammerblock gefunden
		char klammerblock[256], dummy[255];
		int lang = pos_2 - pos_1 -1;
		strncpy(klammerblock,pos_1+1, lang);
		*(klammerblock + lang) = 0;
		*pos_1 = 0;
		sprintf(dummy,"%s%lf%s",input,rechner(klammerblock),pos_2+1);
		// Rekursiver Abstieg
		strcpy(input,dummy);
	}
/********************************************************
Das war schon der ganze rekursive Abstieg
********************************************************/
	
	p[PLUS] = 1;
	p[MINUS] = 1;
	p[MAL] = 2;
	p[DIV] = 2;
	p[END] = 0;
	zustand = 0;
	wert=0;
	vorzeichen = PLUS;
	op=PLUS;
	zahlenzeiger = -1;
	opzeiger = 0;
	opkeller[0] = 255;
	do {
		token = lex_mathe(input, &zahl);
		zustand = parsetable[zustand][token];
		switch (zustand) {
		case 0: // Operator gefunden
			if (opkeller[opzeiger] == 255) { // erster Operator auf Keller
				opkeller[++opzeiger] = token;
			}
			else if (p[token] > p[opkeller[opzeiger]]) { // Hhere Prioritt
				opkeller[++opzeiger] = token;
			}
			else {
				while (opzeiger && p[token] <= p[opkeller[opzeiger]]) {
					zahl_1 = zahlenkeller[zahlenzeiger--];
					zahl_2 = zahlenkeller[zahlenzeiger--];
					op = opkeller[opzeiger--];
					switch (op) {
					case PLUS:	wert = zahl_2 + zahl_1;
								break;
					case MINUS: wert = zahl_2 - zahl_1;
								break;
					case MAL:	wert = zahl_2 * zahl_1;
								break;
					case DIV:	wert = zahl_2 / zahl_1;
								break;
					default:	printf("Fehler im Operator!\n");
					}
					zahlenkeller[++zahlenzeiger] = wert;
				}
				if (token) {
					opkeller[++opzeiger] = token;
				}
			}					
			break;
		case 1: // Zahl gefunden
			zahl = (vorzeichen == PLUS) ? zahl : -zahl;
			zahlenkeller[++zahlenzeiger] = zahl;
			vorzeichen=PLUS; // Default-Vorzeichen fr nchste Zahl
				break;
			case 2: // Vorzeichen merken
				vorzeichen = token;
				break;
			default:
		}
	} while (token);
		
	if (zustand != 4)
		return zahlenkeller[0];
	printf("Eingabe war nicht OK!\n");
}

int main() {
	char input[255];
	while (1) {
		printf("Brauche Input: ");
		fgets(input,255,stdin);
		input[strlen(input)-1] = 0;
		if (!*input)
			break;
		printf("Ergebnis: %lf\n",rechner(input));
	}
}
