/******************************************************************
Wandelt Kleinbuchstaben in Grossbuchstaben, entfernt Trenner am Anfang
und am Ende, genau ein Trenner zwischen Worten
******************************************************************/

#include <stdio.h>

#define END 0
#define ZAHL 1
#define OPERATOR 2
#define FALSCH 3

char input[255];

int yylex(unsigned char *input,unsigned char *c) {
/***********************************************************
Lexikalische Analyse, schreibt in *c das gefundene Zeichen und
gibt ein Token zurck
***********************************************************/
	static int pos;
	static unsigned char myinput[255]="";
	
	if (strcmp(input,myinput)) {
		strcpy(myinput,input);
		pos=0;
	}
	*c = myinput[pos++];
	if (*c =='\n')
		return END;
	if (*c >= '0' && *c <= '9')
		return ZAHL;
	switch (*c) {
	case '+':
	case '-':
	case '*':
	case '/': return OPERATOR;
	default: return FALSCH;
	}
}

int main() {
	int zustand = 0, token;
	unsigned char zeichen;
	int parsetable[4][4] = {{3,1,3,3},
							{3,1,2,3},
							{3,1,3,3},
							{3,3,3,3}};
	unsigned char fstring[4][4][15] ={
			{"LEER",	"",		"FEHLER",	"Fehler"},
			{"OK",		"",		"",			"Fehler"},
			{"FEHLER",	"",		"FEHLER",	"Fehler"},
			{"",		"",		"",			""}};
	while (fgets(input,200,stdin)) {
		zustand=0;
		do {
			token = yylex(input,&zeichen);
			printf("%s",fstring[zustand][token]);
			zustand = parsetable[zustand][token];
		} while (zustand != 3);
		printf("\n");
	}
	printf("\n");
}