/**********************************************************
Berechnet arithmetische Ausdrcke
EBNF:
expression = term {("+"|"-") term}.
term       = factor {("*"|"/") factor}.
factor     = "zahl" | "(" expression ")"
**********************************************************/
#include <stdio.h>
#include "automaten_mathe_scanner.c"

// Prototypen sind wegen indirekter Rekursion ntig!
int factor(double *);
int expression(double *);
int term(double *);
void get_next_token();

char text[255];
int token;
double zahl;

void get_next_token() {
    token = mathescanner(text, &zahl);
}

int factor (double *erg) {
    double z;
    int error;
    if (token == ZAHL) {
        *erg = zahl;
        get_next_token();
        return 0;
    }
    else if (token == KLA_AUF) {
        get_next_token();
        error = expression(&z);
        if (error)
            return error;
        if (token == KLA_ZU) {
            *erg = z;
            get_next_token();
            return 0;
        }
        else
            return 1;
    }
    else
        return 1;
}

int term(double *erg) {
    double z;
    int error, op;
    error = factor(&z);
    if (error)
        return error;
    else
        *erg = z;
    while((op = token) == MAL || op == DIV) {
        get_next_token();
        error = factor(&z);
        if (error)
            return error;
        if (op == MAL)
            *erg *= z;
        else
            *erg /= z;
    }
    return 0;
}

int expression(double *erg) {
    double z;
    int error, op;

    error = term(&z);
    if (error)
        return error;
    else
        *erg = z;
    while((op = token) == PLUS || op == MINUS) {
        get_next_token();
        error = term(&z);
        if (error)
            return error;
        if (op == PLUS)
            *erg += z;
        else
            *erg -= z;
    }
    return 0;
}

int main() {
    double z;
    while(printf("Input:"), fgets(text,255,stdin)!= NULL) {
        mathescanner(text, NULL); // Scanner-Reset
        get_next_token();
        if (!expression(&z))
            printf("%lf!\n", z);
        else
            printf("Fehler!\n");
    }
    return 0;
}
