#include <stdio.h>

#define END 0
#define ARTIKEL 1
#define NOMEN 2
#define HILFSVERB 3
#define ADJEKTIV 4

char input[255],yylval[255];

int yylex() {
/***********************************************************
Lexikalische Analyse, schreibt in *c das gefundene Zeichen und
gibt ein Token zurck
***********************************************************/
	static int pos;
	static unsigned char myinput[255]="";
	
	if (strcmp(input,myinput)) {
		strcpy(myinput,input);
		pos=0;
	}
	if (pos>=strlen(myinput)) return END;
	sscanf(myinput+pos,"%s",yylval);
	pos += strlen(yylval)+1;
	if (!strcmp("Der",yylval)) return ARTIKEL;
	if (!strcmp("Die",yylval)) return ARTIKEL;
	if (!strcmp("Das",yylval)) return ARTIKEL;
	if (!strcmp("ist",yylval)) return HILFSVERB;
	if (!strcmp("sind",yylval)) return HILFSVERB;
	if (yylval[0] >= 'A' && yylval[0] <= 'Z') return NOMEN;
	return ADJEKTIV;
}

int main() {
	int zustand = 0, token;
	int parsetable[5][5] = {{4,1,4,4,4},
							{4,4,2,4,4},
							{4,4,4,3,4},
							{4,4,4,4,4},
							{4,1,4,4,4}};
	unsigned char fstring[5][5][15] ={
			{"F",	"",		"F",	"F",	"F"},
			{"F",	"F",	"",		"F",	"F"},
			{"F",	"F",	"F",	"",		"F"},
			{"F",	"F",	"F",	"F",	"OK"},
			{"",	"",		"F",	"F",	"F"}};
	do {
		zustand=0;
		printf("Input bitte: ");
		fgets(input,200,stdin);
		input[strlen(input)-1]=0;
		while (token = yylex(input)) {
//			printf("token %d Zustand %d gehe zu %d\n",token,zustand,parsetable[zustand][token]);
			if (fstring[zustand][token][0])
				printf("%s %s\n",fstring[zustand][token],yylval);
			zustand = parsetable[zustand][token];
		};
		if (zustand != 4)
			printf("Fehler, Endzustand nicht erreicht!");
		printf("\n");
	} while (strlen(input));
	printf("\n");
}