/**********************************************************
Erkennung von Fixkommazahlen
Regulrer Ausdruck:
[0-9]+("."[0-9]+)?
**********************************************************/
#include <stdio.h>

int scanner(char *, int); // Prototypen
int automat(char *);

enum {E, Z, P, R};  // Token, Eingabealphabet

int main() {
    char input[255];

    while (printf("\nInput:"),scanf("%s", input) != EOF)
        printf("\nZahl%s OK!", (!automat(input))? "":" nicht");

    printf("\n");
    return 0;
}

int automat(char *in) {
// Rckgabe 0: eingabe OK; Rckgabe 1: Eingabe NICHT OK
    int zustand = 0;
    int ptable[][4] = {{4,1,4,4},
                       {5,1,2,4},
                       {4,3,4,4},
                       {5,3,4,4}};

    scanner(in, 1);
    while (zustand <4)
        zustand = ptable[zustand][scanner(in, 0)];
    return (zustand == 4);
}

int scanner(char *in, int reset) {
    static char *p;
    char c;
    if (reset) { // p auf in setzen
        p = in;
        return E;
    }
    c = *(p++);
    if (c >= '0' && c <= '9') return Z; // Ziffer
    if (c == '\0') return E;            // Ende
    if (c == '.') return P;             // Dezimalpunkt
    return R;                           // Rest
}
