/**********************************************************
Erkennung von Fixkommazahlen
Regulrer Ausdruck:
[0-9]+("."[0-9]+)?
**********************************************************/
#include <stdio.h>

int scanner(char *, int); // Prototypen
int automat_t(char *);
int automat_p(char *);

enum {E, Z, P, R};  // Token, Eingabealphabet

int main() {
    char input[255];

    while (printf("\nInput:"),scanf("%s", input) != EOF) {
        printf("\nT:%s OK!", (!automat_t(input))? "":" nicht");
        printf("\nP:%s OK!", (!automat_p(input))? "":" nicht");
    }
    printf("\n");
    return 0;
}

int automat_t(char *in) { // Tabellengesteuerter Automat
// Rckgabe 0: eingabe OK; Rckgabe 1: Eingabe NICHT OK
    int zustand = 0;
    int delta[][4] = {/* 0 1 2 3  Token*/
        /*Zustand 0*/   {4,1,4,4},
        /*Zustand 1*/   {5,1,2,4},
        /*Zustand 2*/   {4,3,4,4},
        /*Zustand 3*/   {5,3,4,4}};

    scanner(in, 1);
    while (zustand <4)
        zustand = delta[zustand][scanner(in, 0)];
    return (zustand == 4);
}

int automat_p(char *in) { // Programmgesteuerter Automat
// Rckgabe 0: eingabe OK; Rckgabe 1: Eingabe NICHT OK
    int zustand = 0, token;

    scanner(in, 1); // Scanner-Reset
    while (zustand <4) {
        token = scanner(in, 0);
        switch (zustand) {
        case /*Zustand*/ 0: switch (token) {
                case 0: zustand = 4; break;
                case 1: zustand = 1; break;
                case 2: zustand = 4; break;
                case 3: zustand = 4; break;
                }
                break;
        case /*Zustand*/ 1: switch (token) {
                case 0: zustand = 5; break;
                case 1: zustand = 1; break;
                case 2: zustand = 2; break;
                case 3: zustand = 4; break;
                }
                break;
        case /*Zustand*/ 2: switch (token) {
                case 0: zustand = 4; break;
                case 1: zustand = 3; break;
                case 2: zustand = 4; break;
                case 3: zustand = 4; break;
                }
                break;
        case /*Zustand*/ 3: switch (token) {
                case 0: zustand = 5; break;
                case 1: zustand = 3; break;
                case 2: zustand = 4; break;
                case 3: zustand = 4; break;
                }
                break;
        }
    }
    return (zustand == 4);
}

int scanner(char *in, int reset) {
    static char *p;
    char c;
    if (reset) { // p auf in setzen
        p = in;
        return E;
    }
    c = *(p++);
    if (c >= '0' && c <= '9') return Z; // Ziffer
    if (c == '\0') return E;            // Ende
    if (c == '.') return P;             // Dezimalpunkt
    return R;                           // Rest
}
