/******************************************************************
Wandelt Kleinbuchstaben in Grossbuchstaben, entfernt Trenner am Anfang
und am Ende, genau ein Trenner zwischen Worten
******************************************************************/

#include <stdio.h>

#define END 0
#define TRENNER 1
#define ZEICHEN 2

char input[255];

int yylex(unsigned char *c) {
/***********************************************************
Lexikalische Analyse, schreibt in *c das gefundene Zeichen und
gibt ein Token zurck
***********************************************************/
	static int pos;
	*c = input[pos++];
	if (*c =='\n') {
		pos=0;
		return END;
	}
	if (*c >= 'A' && *c <= 'Z')
		return ZEICHEN;
	if (*c >= 'a' && *c <= 'z') {
		*c = *c - 32;
		return ZEICHEN;
	}
	return TRENNER;
}

int main() {
	int zustand = 0, token;
	unsigned char zeichen;
	int parsetable[4][3] = {{3,0,1},
							{3,2,1},
							{3,2,1},
							{3,3,3}};
	unsigned char fstring[4][3][5] = {	{"","","%c"},
										{"","","%c"},
										{"",""," %c"},
										{"","",""}};
	while (fgets(input,200,stdin)) {
		zustand=0;
		do {
			token = yylex(&zeichen);
//			printf("Zustand %d fstring %s\n",zustand,fstring[zustand][token]);
			printf(fstring[zustand][token],zeichen);
			zustand = parsetable[zustand][token];
		} while (zustand != 3);
		printf("\n");
	}
	printf("\n");
}