#include "cpp_c_r.h"

c_R::c_R() {
    rwert = 0;
}

c_R c_R::operator + (const c_R& rhs) {
    c_R result;
    result.rwert = rwert + rhs.rwert;
    return result;
}

c_R c_R::operator * (const c_R& rhs) {
    c_R result;
    result.rwert = 1 / (1 / rwert + 1 / rhs.rwert);
    return result;
}

c_R c_R::operator = (const double& rhs) {
    c_R result;
    result.rwert = rhs;
    this->rwert = rhs;
    return result;
}

c_R c_R::operator = (const int& rhs) {
    c_R result;
    result.rwert = rhs;
    this->rwert = rhs;
    return result;
}

c_R c_R::operator += (const double& rhs) {
    c_R result;
    result.rwert = (this->rwert += rhs);
    return result;
}

c_R c_R::operator ++ () {
    c_R result;
    rwert++;
    result = rwert;
    return result;
}

c_R c_R::operator ++ (int) { // Postfix
    c_R result;
    result = rwert;
    rwert++;
    return result;
}

ostream& operator << (ostream& out, const c_R& r) {
    char f[][2]={"","K","M"};
    int e = (r.rwert) ? (int) floor(log10(r.rwert)) / 3 : 0;
    out << r.rwert/pow(10,3*e) << " " << f[e] << "Ohm";
    return out;
}

istream& operator >> (istream& in,  c_R& r){
    in >> r.rwert;
    return in;
}

c_R::operator double () {
    return rwert;
}
