/*********************************************************************
Klasse c_string
*********************************************************************/
#include <iostream.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

c_string::c_string() { // Konstruktor
//    cout << "Konstruktor!" << endl;
    l = 0;
    s = 0;
}

c_string::c_string(char * text) { // Konstruktor
    s = 0;
    l = 0;
    set(text, strlen(text));
}

c_string::c_string(const c_string& neu) { // Kopierkonstruktor
    s = 0;
    l = 0;
    set(neu.s, neu.l);
}

c_string::~c_string() { // Destruktor
    set("", 0);
}

void c_string::set(char *text) {
    set(text, strlen(text));
}

void c_string::set(char *text, unsigned int length) {
	if (s != NULL)
		free(s);
	l = length;
	if (l) {
    	s = (char *) malloc(length);
    	memcpy(s,text,length);
    }
    else
        s = NULL;
}

void c_string::operator = (c_string string2) {
    set(string2.s, string2.l);
}

void c_string::operator += (c_string string2) {
    c_string dummy;
    dummy.set(s, l);
    dummy = dummy + string2;
    set(dummy.s, dummy.l);
}

void c_string::operator = (char *t) {
	set(t);
}

ostream& operator << (ostream& out, c_string string) {
	char *p = string.s;
	for (unsigned int i=0; i < string.l; i++)
	    out << *(p++);
	return out;
}

istream& operator >> (istream& in, c_string& string) {
	char p[1024];
	in >> p;
	string.set(p);
	return in;
}

unsigned int c_string::length(void) {
	return l;
}

c_string c_string::upper(void) {
    c_string result;
    result.set(s, l);
    for (int i=0; i<result.l; i++)
        *(result.s +i) = toupper(*(result.s +i));
    return result;
}

c_string c_string::lower(void) {
    c_string result;
    result.set(s, l);
    for (int i=0; i<result.l; i++)
        *(result.s +i) = tolower(*(result.s +i));
    return result;
}

c_string c_string::operator + (c_string rechts) { // Concatenate
	c_string result;
	char * p = (char *) malloc(l + rechts.l + 1);
    strncpy(p, s, l);
	strncpy(p + l, rechts.s, rechts.l);
	*(p + l + rechts.l) = 0;
	result = p;
	return result;
}

int c_string::operator == (c_string& s2) {
	if (l != s2.l)
		return 0;
	return strncmp(s, s2.s, l) == 0;
}

int c_string::operator != (c_string& s2) {
	if (l != s2.l)
		return 1;
	return strncmp(s, s2.s, l) != 0;
}

int c_string::operator == (char *s2) {
	if (l != strlen(s2))
		return 0;
	return strncmp(s, s2, l) == 0;
}


int c_string::operator != (char *s2) {
	if (l != strlen(s2))
		return 1;
	return memcmp(s, s2, l) != 0;
}

int c_string::operator < (c_string& s2) {
	int dummy = memcmp(s, s2.s, (l <= s2.l)? l:s2.l);
	return (dummy == 0 && l < s2.l) ? 1 : (dummy < 0);
}

int c_string::operator > (c_string& s2) {
	int dummy = memcmp(s, s2.s, (l <= s2.l)? l:s2.l);
	return (dummy == 0 && l > s2.l) ? 1 : (dummy > 0);
}

int c_string::operator <= (c_string& s2) {
	int dummy = memcmp(s, s2.s, (l <= s2.l)? l:s2.l);
	return (dummy == 0 && l > s2.l) ? 0 : (dummy < 1);
}

int c_string::operator >= (c_string& s2) {
	int dummy = memcmp(s, s2.s, (l <= s2.l)? l:s2.l);
	return (dummy == 0 && l < s2.l) ? 0 : (dummy > -1);
}

c_string c_string::operator[] (int index) {
    c_string result;
    if (index < l)
    result.set(s + index, 1);
    return result;
}
