/**********************************************************
Liest wahlweise von stdin oder Datei (Dateiname per
Kommandozeilenparameter bergeben) und gibt Dateiinhalt
hexadezimal aus (16 Zeichen pro Zeile
**********************************************************/
#include <stdio.h>

int main(int argc, char * argv[]) {
    FILE *f;
    unsigned char c;
    int i;
    const int linelength = 16;

    if (argc > 1) {
        f = fopen(argv[1], "r");
        if (f == NULL) {
            fprintf(stderr, "Fehler Datei '%s'!\n", argv[1]);
            return 1;
        }
    }
    else
        f = stdin;

    i = -1;
    while (fscanf(f, "%c", &c) != EOF) {
        if (++i % linelength == 0)
            printf("%.4XX:", i);
        printf(" %.2X", c);
        if (i % linelength == linelength - 1)
            printf("\n");
    }
    fprintf(stderr, "%d Zeichen gelsen\n", i);
    return 0;
}

