/**********************************************************
Kopiert Eingabedatei in formatierte Ausgabedatei
(12 Stellen + Zeilenumbruch fr jede Zahl) und sortiert
anschliessend die Ausgabedatei.

Zugriff auf formatierte Textdatei erfolgt ber Funktionen
reeadfromfile() und writetofile()
**********************************************************/
#include <stdio.h>

FILE *in, *out;

int readfromfile(int pos) {
    int zahl;
    fseek(out, 13*pos, SEEK_SET);
    fscanf(out,"%d", &zahl);
    return zahl;
}

void writetofile(int pos, int zahl) {
    fseek(out, 13*pos, SEEK_SET);
    fprintf(out,"%12d", zahl);
}

int main(int argc, char *argv[]) {
    int zahl, z1, z2, anz=0, i, j;

    if (argc != 3) {
        fprintf(stderr,"Aufruf mit zwei Dateinamen!");
        return 1;
    }
    in = fopen(argv[1], "r");
    if (in == NULL) {
        fprintf(stderr, "Kann Eingabedatei nicht ffnen!");
        return 1;
    }
    out = fopen(argv[1], "w+");
    if (out == NULL) {
        fprintf(stderr, "Kann Ausgabedatei nicht ffnen!");
        return 1;
    }

    while (fscanf(in, "%d", &zahl) != EOF) {
        fprintf(out, "%12d\n", zahl);
        anz++;
    }
    fclose(in);

    for (i = 0; i < anz; i++)
        for (j = 0; j < anz-1; j++) {
            z1 = readfromfile(j);
            z2 = readfromfile(j+1);
            if (z1 > z2) {
                writetofile(j, z2);
                writetofile(j+1, z1);
            }
        }
    fclose(out);
}