#include <stdio.h>
#include <malloc.h>

struct element {
    double value;
    struct element *next;
};

struct element *anfang = NULL, *ende = NULL;

int addlist(double v) {
    struct element *neu = (struct element *) malloc(sizeof(struct element));
    struct element *lauf1, *lauf2;
    if (neu == NULL) return 1;

    neu->value = v;
    if (anfang == NULL) { // Neue Liste
        anfang = neu;
        ende = neu;
        neu->next = NULL;
    }
    else switch((v > ende->value) - (v < anfang->value)) {
    case -1: // Neues erstes Element
                neu->next = anfang;
                anfang = neu;
                break;
    case +1: // Neues letztes Element
                neu->next = NULL;
                ende->next = neu;
                ende = neu;
                break;
    default: // Einfgen innerhalb Liste
                lauf1 = anfang;
                lauf2 = anfang->next;
                while (v > lauf2->value) {
                    lauf1 = lauf2;
                    lauf2 = lauf2->next;
                }
                if (v < lauf2->value && v > lauf1->value) {
                    lauf1->next = neu;  // Neuer Datensatz
                    neu->next = lauf2;
                }
                else
                free(neu); // Nicht speichern
    } // switch
    return 0;
}

int dellist(double v) {
    struct element *puffer, *lauf1, *lauf2;

    if (v == anfang->value) { //Erstes Element
        puffer = anfang;
        anfang = anfang->next;
        if (anfang == NULL)
            ende = NULL;
        free(puffer);
        return 0;
    }

    lauf1 = anfang;
    while (lauf1 != NULL) {
        lauf2 = lauf1->next;
        if (v == lauf2->value) {
            lauf1->next = lauf2->next;
            if (lauf1->next == NULL)
                ende = NULL;
            free(lauf2);
            return 0;
        }
    }
    return 1; // Nicht gefunden
}

int printlist() {
    struct element *lauf = anfang;
    int nr = 0;

    while (lauf != NULL) {
        printf("\n%d: %lf",nr++,lauf->value);
        lauf = lauf->next;
    }
    printf("\n%d Eintrge",nr);
}

int main () {
    char wahlstring[10];
    double zahl;
    int wahl;

    do {
        printlist();
        printf("\n1) In Liste speichern");
        printf("\n2) Aus Liste lschen");
        printf("\n3) Ende");
        printf("\nIhre Wahl: ");
        scanf("%s",wahlstring);
        wahl = atoi(wahlstring);
        if (wahl == 1) {
            printf("\nZahl eingeben: ");
            scanf("%lf",&zahl);
            if (addlist(zahl))
                printf(" Kein Speicherplatz mehr!");
        }
        if (wahl == 2) {
            printf("\nZahl eingeben: ");
            scanf("%lf",&zahl);
            if (!dellist(zahl))
                printf("\nGelscht!");
            else
                printf("\nNicht gefunden!");
        }
    } while (wahl != 3);
    return 0;
}
