/**********************************************************
Demonstriert den Unterschied zwischen Wert- und
Adressbergabe. Die Funktionen swap_by_value und
swap_by_reference sollen jeweils die Werte der Variablen
im Hauptprogramm vertauschen. Dies funktioniert aber
nur bei swap_by_reference!!!!
**********************************************************/
#include <stdio.h>

void swap_by_value(double a, double b) { // Zahlenwerte!!!
    double dummy = a;
    a = b;
    b = dummy;
} // Dreieckstausch hat keine Auswirkungen ausserhalb des Moduls!

void swap_by_reference(double *a, double *b) { // Zeigern!!!
    double dummy = *a;
    *a = *b;
    *b = dummy;
} // Dreieckstausch hat Auswirkungen ausserhalb des Moduls!

int main () {
    double x = 1.2, y = 2.7;

    printf("Ausgangswerte:\tx=%lf\ty=%lf\n", x, y);
    swap_by_value(x, y);
    printf("swap_by_value:\tx=%lf\ty=%lf\n", x, y);
    swap_by_reference(&x, &y);
    printf("swap_by_ref  :\tx=%lf\ty=%lf\n", x, y);
    return 0;
}