/**********************************************************
Drehen eines Vektors
Modul drehe mit "call-by-reference"
**********************************************************/
#include <stdio.h>
#include <math.h>

// Prototypen
void drehe(double *, double *, double);
void ausgabe(double, double, char *);

int main() {
    double x1, x2, winkel;

    printf("Geben Sie die Vektorkoordinaten sowie");
    printf(" den Drehwinkel in Grad ein:");
    scanf("%lf%lf%lf", &x1, &x2, &winkel);
    ausgabe(x1, x2, "Vor Drehung:");
    drehe(&x1, &x2, winkel);
    ausgabe(x1, x2, "Nach Drehung:");
}

void drehe(double *x, double *y, double alpha) {
    double hilf_x = *x;

    alpha = alpha / 180 * M_PI; // M_PI in math.h definiert
    *x = hilf_x * cos(alpha) - *y * sin(alpha);
    *y = hilf_x * sin(alpha) + *y * cos(alpha);
}

void ausgabe(double a, double b, char *text) {
    printf("%s\t[%lf/%lf]\n", text, a, b);
}
