/***********************************************************
Lsung eines linearen 3*3-Gleichungssystems nach der
Cramerschen Regel
***********************************************************/

#include <stdio.h>

#define DIMENSION 3
	
double B[DIMENSION][DIMENSION];

double determinante(){
// Berechnet die Determinante der im globalen Array B
// gespeicherten Matrix
    double erg = 0;
    int i;

    for (i=0; i<DIMENSION; i++) {
        erg += B[0][i]*B[1][(i+1)%DIMENSION]*B[2][(i+2)%DIMENSION];
        erg -= B[0][i]*B[1][(i-1+DIMENSION)%DIMENSION] *
            B[2][(i-2+DIMENSION)%DIMENSION];
    }
    return erg;
}

int main() {
    int zeile, spalte, k;
    double A[DIMENSION][DIMENSION] = {	{4,2,1},
    									{2,1,0},
    									{3,2,1}};
    double d, X[DIMENSION], Y[DIMENSION] = {9,8,5};

    for (zeile=0; zeile<DIMENSION; zeile++) {
        printf("|");
        for (spalte=0; spalte<DIMENSION; spalte++)
            printf("%10.4lf",A[zeile][spalte]);
        printf("|   |X%d|    |%10.4lf|", zeile+1, Y[zeile]);
        printf("\n");
    }
    // Schritt 1: Matrix A nach B kopieren und Det. berechnen
    for (zeile=0; zeile<DIMENSION; zeile++)
        for (spalte=0; spalte<DIMENSION; spalte++)
            B[zeile][spalte] = A[zeile][spalte];
    if ((d = determinante()) == 0)
        printf("Gleichungssystem hat keine Lsung!\n");
    else {
        /* Schritt 2: Dreimal Matrix A nach B kopieren und dabei
        Jede Spalte der Matrix einmal durch Zielvektor ersetzen */
        printf("Ergebnis: \n");
        for (k=0; k<DIMENSION; k++) {
            for (spalte=0; spalte<DIMENSION; spalte++)
                for (zeile=0; zeile<DIMENSION; zeile++)
                    B[zeile][spalte] =
                        (spalte == k)? Y[zeile] : A[zeile][spalte];
            printf("X%d = %lf\n",k+1, determinante() / d);
        }
    }
}