/**********************************************************
Lsung von linearen Gleichungssystemen nach dem
Gauss-Verfahren (Dreiecksform)
**********************************************************/
#include <stdio.h>
#include <math.h>

void ausgabe(double *, int);
int gauss(double *, int);
int main() {
/*    double a[5][6]={    { 6,-3, 2, 1,-1, 5},
                        { 3, 7, 0,-4, 2,11},
                        { 4,-3, 6,-1, 2,22},
                        { 2, 4, 5,-7,-3,-18},
                        {-1, 5,-4, 0, 8,37}};*/
    double a[3][4]={{3,0,0,2},{0,1,0,3},{0,0,0,4}};

    if (gauss(&(a[0][0]), 3))
        printf("Singulre Matrix!!!\n");
    return 0;
}

int gauss(double *a, int n) {
    int s, z, singulaer=0, i, dummy;
    int mult = 1;
    double m, *x; // max
    x = (double *) malloc(n * sizeof(double));
    if (x == NULL)
        return 2; // Kein Speicher frei
    ausgabe(a, n);
    for (s = 0; s < n-1; s++) {
        m = 0;
        i = 0;
        for (z = s; z < n; z++) // Max. Element suchen
            if (fabs(*(a+z*(n+1)+s)) > fabs(m)) {
                m = *(a+z*(n+1)+s);
                i = z;
            }
        if (fabs(m) < 1E-8)
            return 1; // Singulre Matrix!!!!
        printf("Max-Element %lf in Zeile %d statt %d!\n", *(a+i*(n+1)+s), i, s);
        if (i != s) {// Tauschen Zeile i mit Zeile s
            for (dummy = 0; dummy < n+1; dummy++) {
                m = *(a + s *(n+1) +dummy);
                *(a + s * (n+1) + dummy) = *(a + i*(n+1) + dummy);
                *(a + i*(n+1) +dummy) = m;
            }
            mult = -mult;
        }
        for (z = s+1; z<n; z++) if (*(a+z*(n+1)+s)){
            m = *(a+s*(n+1)+s) / *(a+z*(n+1)+s);
            printf("\t%lf", m);
            for (dummy = 0; dummy < n+1; dummy++)
                *(a+z*(n+1)+dummy)-= (*(a+s*(n+1)+dummy)/m);
        }
        ausgabe(a, n);
    }
    x[n-1] = *(a + (n-1) * (n+1) + n) / *(a + (n-1) * (n+1) + n-1);
    for (s = n-2; s>=0; s--) {
        m = *(a + s * (n+1) + n);
        for (dummy = s+1; dummy < n; dummy++)
            m = m - *(a + s * (n+1) + dummy) * x[dummy];
        x[s] = m / *(a + s*(n+1)+s);
    }
    for (dummy=0; dummy<n; dummy++)
        printf("  %lf", x[dummy]);
    m = mult;
    for (dummy=0; dummy<n; dummy++)
        m *= *(a + dummy * (n+1) + dummy);
    printf("\n%lf\n", m);
    return 0;
}

void ausgabe(double *a, int n) {
    int i, j;
    printf("\n");
    for (i=0; i<n; i++) {
        for (j=0; j<n+1; j++)
            printf("%13lf", *(a + (n+1) * i + j));
        printf("\n");
    }
    printf("\n");
}