/***********************************************************
Trme von Hanoi - grafische Lsung
***********************************************************/
#include <stdio.h>
#define MAX_H 10

int turm[3][MAX_H + 1], hoehe;

void ausgabe() {
    int lhoehe, lturm, zahl, i;

    for (lhoehe = hoehe; lhoehe >0; lhoehe--) {
        for (lturm = 0; lturm <3; lturm ++) {
            printf("  ");
            zahl =  turm[lturm][lhoehe];
            if (!zahl) {
                for (i=0; i<hoehe-1; i++) printf(" ");
                printf("|");
                for (i=0; i<hoehe-1; i++) printf(" ");
            }
            else {
                for (i=0; i<hoehe-zahl; i++) printf(" ");
                for (i=0; i<2*zahl-1; i++) printf("X");
                for (i=0; i<hoehe-zahl; i++) printf(" ");
            }
        }
        printf("\n");
    }
}

void hanoi(int turm_von, int turm_nach, int turm_via, int hoehe){
    static int zugnr;
    int hvon, hnach;
	
	if (hoehe>1)
		hanoi(turm_von, turm_via, turm_nach, hoehe-1);	
	
	printf("\nZug %d: %d nach %d\n", ++zugnr, turm_von+1, turm_nach+1);
    turm[turm_nach][++turm[turm_nach][0]] =
        turm[turm_von][turm[turm_von][0]];
    turm[turm_von][turm[turm_von][0]--] = 0;
	ausgabe();
	
	if (hoehe>1)
		hanoi(turm_via, turm_nach, turm_von, hoehe-1);	
}

int main(){
    int i;

	printf("Geben Sie die Turmhoehe ein: ");
	scanf("%d",&hoehe);
	
	turm[0][0] = hoehe;
	turm[1][0] = 0;
	turm[2][0] = 0;
	
	for (i=1; i<=MAX_H; i++) {
	    turm[0][i] = hoehe - i +1;
	    turm[1][i] = 0;
	    turm[2][i] = 0;
	}
	
	printf("Ausgangslage:\n");
	ausgabe();
	
	hanoi(0,1,2,hoehe);
// Bewege Turm mit Hhe h von Stange 0 nach Stange 1 ber Stange 2
	return 0;
}