/**************************************************************
Labyrinth: Eine Maus starten in Zelle 0/0 und soll den Kaese
in Zelle 4/4 finden. Beispiel fuer einen Backtracking-Algorithmus
**************************************************************/
#include <stdio.h>
#define n 5 // Labyrinthgre
char feld[n][n]={   {' ',' ','X','X',' '},
                    {'X',' ',' ',' ',' '},
                    {' ',' ','X',' ','X'},
                    {' ','X',' ',' ',' '},
                    {' ',' ',' ','X','@'}};
// ' ' = Weg, 'X' = Mauer, '@' = Kse
char allesausgeben;

void ausgabe(char *text) {
	int i,j;
	printf("\n+");
	for (i=0; i<n;i++)
	    printf("-");
	printf("+");
	for (i=0; i<n;i++) {
	    printf("\n|");
	    for (j=0; j<n; j++)
		    printf("%c", feld[i][j]);
	    printf("|");
	}
	printf("\n+");
	for (i=0; i<n;i++)
	    printf("-");
	printf("+");
	printf("%s\n", text);
	getc(stdin); // evtl. auskommentieren!
}

void mauszug(int zeile, int spalte) {
	if (zeile >= 0 && spalte >= 0 && zeile < n && spalte < n
    && feld[zeile][spalte] != 'X' && feld[zeile][spalte]!=':')
    { // Zug trifft Labyrinth und Feld ist noch frei
    	if (feld[zeile][spalte] == '@') { // Kse gefunden!!!!!
	        feld[zeile][spalte] = '#'; // Kse fressen
	        ausgabe("Hmmm, leckerer Kse!");
    	    feld[zeile][spalte] = '@'; // Kse wiederherstellen ;-)
        } // if
        else {	
        	feld[zeile][spalte]=':'; // Feld als besetzt markieren
		    if (allesausgeben)
			    ausgabe("");
    		mauszug(zeile+1, spalte); // rekursive Aufrufe
	    	mauszug(zeile, spalte+1);
		    mauszug(zeile-1, spalte);
    		mauszug(zeile, spalte-1);
	    	if (allesausgeben)
		    	ausgabe("");
        	feld[zeile][spalte]=' '; // Feld freigeben!!!
	    } // else
	} // if
} // mauszug

int main() {
	char antwort[10];
	printf("Wollen Sie jeden mauszug ausgeben? ");
	scanf("%s",antwort);
	allesausgeben = antwort[0]=='J' || antwort[0]=='j';
	ausgabe("");
	mauszug(0, 0);
	return 0;
}