/**********************************************************
Eingabe, Sortierung und Ausgabe von zwei Studenten
**********************************************************/
#include <stdio.h>

typedef struct {
    char nachname[30], vorname[30];
    int matrikelnr, erstsemester;
} student;

void student_sort(student *, int);
student student_eingabe(int);
void student_ausgabe(student);
void student_tausch(student *, student *);

int main() {
    student *s;
    int anz, i;

    while(1) {
        printf("Wieviele Studenten sind zu sortieren?");
        scanf("%d", &anz);
        if (anz>0)
            break;
        printf("\aFehler!\n");
    }

    if ((s = (student *) malloc(anz * sizeof(student))) == 0) {
        printf("Kein Speicherplatz!\n");
        return 1;
    }
    for (i=0; i<anz; i++)
        *(s+i) = student_eingabe(i);
    student_sort(s, anz);
    printf("\n");
    for (i=0; i<anz; i++)
        student_ausgabe(*(s+i));
    return 0;
}

void student_tausch(student *a, student *b) {
    student dummy = *a;
    *a = *b;
    *b = dummy;
}

void student_sort(student *a, int anzahl) {
    int i, j;
    for (i = 0; i < anzahl-1; i++)
        for (j = 0; j < anzahl-1; j++)
            if (strcmp((a+j)->nachname, (a+j+1)->nachname) > 1
                || !strcmp((a+j)->nachname, (a+j+1)->nachname)
                && strcmp((a+j)->vorname, (a+j+1)->vorname)>1)
                    student_tausch(a+j, a+j+1);
}

student student_eingabe(nr) {
    student s;
    printf("Studenten-Eingabe %d:\n", nr);
    printf("Nachname:     ");
    scanf("%s", s.nachname);
    printf("Vorname:      ");
    scanf("%s", s.vorname);
    printf("Matrikelnr    ");
    scanf("%d", &s.matrikelnr);
    printf("Erstsemester: ");
    scanf("%d", &s.erstsemester);
    return s;
}

void student_ausgabe(student s){
    printf("%30s %30s", s.nachname, s.vorname);
    printf("%8d%6d\n", s.matrikelnr, s.erstsemester);
}
