/**********************************************************
Konvertiert Input in Grossbuchstaben.
Drei Aufrufmglichkeiten:
1) Ohne Parameter: stdin -> stdout
2) Ein Parameter: Konvertiert Datei
3) Zwei Parameter Kopiert Datei und konvertiert.
**********************************************************/

#include <stdio.h>

int main(int argc, char * argv[]) {
    FILE *in, *out;
    char c;

    switch (argc) {
    case 1: in = stdin;
            out = stdout;
            break;
    case 2: in = fopen(argv[1], "r+");
            if (in == NULL) {
                fprintf(stderr, "Fehler Eingabedatei!\n");
                return 1;
            }
            out = in;
            break;
    case 3: in = fopen(argv[1], "r");
            if (in == NULL) {
                fprintf(stderr, "Fehler Eingabedatei!\n");
                return 1;
            }
            out = fopen(argv[2], "w");
            if (out == NULL) {
                fprintf(stderr, "Fehler Ausgabedatei!\n");
                fclose(in);
                return 2;
            }
            break;
    default: fprintf(stderr, "Max. zwei Parameter!\n");
             return 3;
    }
    if (argc == 1 || argc == 3) {
        if (argc == 3)
            fprintf(stderr,"Konvertiere %s -> %s!\n", argv[1], argv[2]);
        while(fscanf(in, "%c", &c) != EOF)
            fprintf(out, "%c", toupper(c));
        if (argc == 3) {
            fclose(in);
            fclose(out);
        }
    }
    else {
        fprintf(stderr,"Konvertiere %s!\n", argv[1]);
        while(fscanf(in, "%c", &c) != EOF) {
            fseek(in, -1, SEEK_CUR); // Ein Zeichen zurck
            fprintf(in, "%c", toupper(c));
        }
        fclose(in);
    }
    return 0;
}
