/**********************************************************
Integriert Polynome
y = a x^n + b x^(n-1) + ...
**********************************************************/
#include <stdio.h>
#include <malloc.h>
#include <math.h>

void polynom_eingabe(double *, int);
void polynom_ausgabe(double *, int);
void polynom_integral(double *, double *, int);
double polynom_fwert(double *, int, double);

int main() {
    int grad;
    double * poly_1, * poly_2, ug, og, integral;

    printf("Geben Sie den Grad des zu integrierenden Polynoms ein: ");
    scanf("%d", &grad);

    poly_1 = (double *) malloc((grad + 1) * sizeof(double));
    polynom_eingabe(poly_1, grad);
    printf("\nSie haben eingegeben:\n");
    polynom_ausgabe(poly_1, grad);
    printf("\n");

    poly_2 = (double *) malloc((grad + 2) * sizeof(double));
    polynom_integral(poly_1, poly_2, grad);

    printf("\nIntegral-Polynom:\n");
    polynom_ausgabe(poly_2, grad + 1);
    printf("\n");

    printf("Geben Sie untere und obere Grenze des Integrals ein: ");
    scanf("%lf%lf", &ug, &og);

    integral = polynom_fwert(poly_2, grad + 1, og)
                - polynom_fwert(poly_2, grad + 1, ug);
    printf("Integral: %lf", integral);
    printf("\n");
    return 0;
}

void polynom_eingabe(double * p, int grad) {
    int i;
    for (i = grad; i >= 0; i--) {
        printf("Koeffizient x^%d :", i);
        scanf("%lf", p + i);
    }
}

void polynom_ausgabe(double * p, int grad) {
    int i;
    printf("y = %.2lf x^%d", *(p + grad), grad);
    for (i = grad - 1; i >= 0; i--)
        printf("  +  %.2lf x^%d", *(p + i), i);
}

void polynom_integral(double * polynom, double * integral, int grad) {
    int i;
    *(integral + 0 ) = 0; // Koeffizient x^0
    for (i = 0; i <= grad; i++)
        *(integral + i + 1) = *(polynom + i) / (i + 1);
}

double polynom_fwert(double * polynom, int grad, double x) {
    int i;
    double fwert = 0;
    for (i = 0; i <= grad; i++)
        fwert += (*(polynom + i) * pow(x, i));
    return fwert;
}
