/**********************************************************
Untersucht, ob es eine vierstellige Quadratzahl q mit
folgenden Eigenschaften gibt:
- Alle Ziffern von q sind kleiner als 7.
- Vergrert man jede Ziffer um 3, so ist die neu
  entstandene Zahl auch eine Quadratzahl.
**********************************************************/
#include <stdio.h>
#include <math.h>

int main() {
    int q, gefunden = 0, z1, z2, z3, z4, q2, w, w2;

    for (q = 1000; q <= 6666; q++) { // Alle mgliche q
        z1 = q / 1 % 10;        // Ziffer ganz rechts
        z2 = q / 10 % 10;
        z3 = q / 100 % 10;
        z4 = q / 1000 % 10;
        w = (int) (0.5 + sqrt(q)); // Gerundete Wurzel
        if (w * w == q && z1 < 7 && z2 < 7 && z3 < 7 && z4 < 7) {
            q2 = (z1 + 3) + 10 * (z2 + 3) +
                 100 * (z3 + 3) + 1000 * (z4 + 3);
            w2 = (int) sqrt(q2);
            if (w2 * w2 == q2) {
                printf("%d^2 = %d -> %d^2 = %d\n", w, q, w2, q2);
                gefunden = 1;
            }
        }
    }
    if (!gefunden)
        printf("Keine solche Zahl gefunden!!!!\n");
    return 0;
}
